> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gr4vy.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Add a payment link

> Create a new payment link.

This endpoint requires the `payment-links.write` scope.


## OpenAPI

````yaml /openapi.speakeasy.json POST /payment-links
openapi: 3.1.0
info:
  title: Gr4vy
  description: The Gr4vy API.
  version: 1.0.0
servers:
  - url: https://api.sandbox.{id}.gr4vy.app
    x-speakeasy-server-id: sandbox
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
  - url: https://api.{id}.gr4vy.app
    x-speakeasy-server-id: production
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
security:
  - bearerAuth: []
tags:
  - name: 3DS scenarios
    description: Manage and create 3DS scenarios in sandbox.
  - name: Account updater
    description: Schedule stored cards for an account update.
  - name: Audit logs
    description: Query user activity.
  - name: Buyers
    description: Manage buyers.
  - name: Buyers - Gift cards
    description: Query gift cards for buyers.
  - name: Buyers - Payment methods
    description: Query payment methods for buyers.
  - name: Buyers - Shipping details
    description: Manage shipping details for buyers.
  - name: Card details
    description: Returns information about a card.
  - name: Card scheme definitions
    description: List definitions for card schemes.
  - name: Checkout sessions
    description: Manage checkout sessions.
  - name: Digital wallets - Sessions
    description: Create sessions for digital wallets like Apple Pay and Google Pay.
  - name: Digital wallets - Setup
    description: Manage digital wallets like Apple Pay and Google Pay.
  - name: Gift cards
    description: Manage stored gift cards.
  - name: Insights
    description: Retrieve Insights data.
  - name: Insights - Presets
    description: Manage presets for Insights.
  - name: Merchant accounts
    description: Manage merchant accounts in an instance.
  - name: Merchant accounts - 3DS configuration
    description: Manage 3DS profiles for merchant accounts.
  - name: Monitoring
    description: Manage monitoring and alerting.
  - name: Payment links
    description: Manage payment links.
  - name: Payment methods
    description: Manage stored payment methods.
  - name: Payment methods - Definitions
    description: Manage payment method definitions.
  - name: Payment methods - Network tokens
    description: Manage network tokens for stored payment methods.
  - name: Payment methods - Payment service tokens
    description: Manage payment service tokens for stored payment methods.
  - name: Payment options
    description: Fetch a list of payment options to display at checkout.
  - name: Payment service definitions
    description: Fetch info about the definition of each payment service.
  - name: Payment services
    description: Manage configured payment services.
  - name: Payouts
    description: Payout API.
  - name: Refunds
    description: Manage transaction refunds.
  - name: Reports
    description: Manage one-off and scheduled reports.
  - name: Reports - Executions
    description: Manage executions of reports.
  - name: Transactions
    description: Manage transaction.
  - name: Transactions - Actions
    description: Read Flow actions triggered for a transaction.
  - name: Transactions - Chargebacks
    description: Read transaction chargeback data.
  - name: Transactions - Chargeback reversals
    description: Read transaction chargeback reversal data.
  - name: Transactions - Settlements
    description: Read transaction settlement data.
  - name: Transactions - Sessions
    description: Manage transaction session data.
  - name: Webhook subscriptions
    description: Manage webhook subscriptions.
paths:
  /payment-links:
    post:
      tags:
        - Payment links
      summary: Add a payment link
      description: Create a new payment link.
      operationId: add_payment_link
      parameters:
        - name: x-gr4vy-merchant-account-id
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: The ID of the merchant account to use for this request.
            examples:
              - default
            title: X-Gr4Vy-Merchant-Account-Id
          description: The ID of the merchant account to use for this request.
          x-speakeasy-name-override: merchantAccountId
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PaymentLinkCreate'
              description: The payment link to create
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaymentLink'
        '400':
          description: The request was invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error400'
        '401':
          description: The request was unauthorized.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error401'
        '403':
          description: >-
            The credentials were invalid or the caller did not have permission
            to act on the resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error403'
        '404':
          description: The resource was not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error404'
        '405':
          description: The request method was not allowed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error405'
        '409':
          description: A duplicate record was found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error409'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '425':
          description: The request was too early.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error425'
        '429':
          description: Too many requests were made.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error429'
        '500':
          description: The server encountered an error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error500'
        '502':
          description: The server encountered an error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error502'
        '504':
          description: The server encountered an error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error504'
      x-codeSamples:
        - lang: java
          label: Java
          source: |-
            package hello.world;

            import com.gr4vy.sdk.Gr4vy;
            import com.gr4vy.sdk.models.components.PaymentLinkCreate;
            import com.gr4vy.sdk.models.errors.*;
            import com.gr4vy.sdk.models.operations.AddPaymentLinkResponse;
            import java.lang.Exception;

            public class Application {

                public static void main(String[] args) throws Exception {

                    Gr4vy sdk = Gr4vy.builder()
                            .id("example")
                            .server(AvailableServers.SANDBOX)
                            .merchantAccountId("default")
                            .securitySource(new BearerSecuritySource.Builder(privateKey).build())
                        .build();

                    AddPaymentLinkResponse res = sdk.paymentLinks().create()
                            .paymentLinkCreate(PaymentLinkCreate.builder()
                                .amount(1299L)
                                .country("DE")
                                .currency("EUR")
                                .store(true)
                                .build())
                            .call();

                    if (res.paymentLink().isPresent()) {
                        System.out.println(res.paymentLink().get());
                    }
                }
            }
        - lang: csharp
          label: C#
          source: >-
            using Gr4vy;

            using Gr4vy.Models.Components;


            var sdk = new Gr4vySDK(
                id: "example",
                server: SDKConfig.Server.Sandbox,
                bearerAuthSource: Auth.WithToken(privateKey),
                merchantAccountId: "default"
            );


            var res = await sdk.PaymentLinks.CreateAsync(paymentLinkCreate: new
            PaymentLinkCreate() {
                Amount = 1299,
                Country = "DE",
                Currency = "EUR",
                Store = true,
            });


            // handle response
        - lang: javascript
          label: TypeScript
          source: |-
            import { Gr4vy, withToken } from "@gr4vy/sdk";
            import fs from "fs";

            const gr4vy = new Gr4vy({
                id: "example",
                server: "sandbox",
                merchantAccountId: "default",
                bearerAuth: withToken({
                  privateKey: fs.readFileSync("private_key.pem", "utf8"),
                }),
            });

            async function run() {
              const result = await gr4vy.paymentLinks.create({
                amount: 1299,
                country: "DE",
                currency: "EUR",
                store: true,
              });

              console.log(result);
            }

            run();
        - lang: python
          label: Python
          source: |-
            from gr4vy import Gr4vy
            import os


            with Gr4vy(
                id="example",
                server="sandbox",
                merchant_account_id="default",
                bearer_auth=auth.with_token(open("./private_key.pem").read())
            ) as g_client:

                res = g_client.payment_links.create(amount=1299, country="DE", currency="EUR", store=True)

                # Handle response
                print(res)
        - lang: go
          label: Go
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tgr4vygo \"github.com/gr4vy/gr4vy-go\"\n\t\"github.com/gr4vy/gr4vy-go/models/components\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := gr4vy.New(\n\t\tgr4vy.WithID(\"example\"),\n\t\tgr4vy.WithServer(gr4vy.ServerSandbox),\n\t\tgr4vy.WithSecuritySource(withToken),\n\t\tgr4vy.WithMerchantAccountID(\"default\"),\n\t)\n\n    res, err := s.PaymentLinks.Create(ctx, components.PaymentLinkCreate{\n        Amount: 1299,\n        Country: \"DE\",\n        Currency: \"EUR\",\n        Store: gr4vygo.Pointer(true),\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res != nil {\n        // handle response\n    }\n}"
        - lang: php
          label: PHP
          source: |-
            declare(strict_types=1);

            require 'vendor/autoload.php';

            use Gr4vy;

            $sdk = Gr4vy\SDK::builder()
                ->setId('example')
                ->setServer('sandbox')
                ->setSecuritySource(Auth::withToken($privateKey))
                ->setMerchantAccountId('default')
                ->build();

            $paymentLinkCreate = new Gr4vy\PaymentLinkCreate(
                amount: 1299,
                country: 'DE',
                currency: 'EUR',
                store: true,
            );

            $response = $sdk->paymentLinks->create(
                paymentLinkCreate: $paymentLinkCreate
            );

            if ($response->paymentLink !== null) {
                // handle response
            }
components:
  schemas:
    PaymentLinkCreate:
      properties:
        buyer:
          anyOf:
            - $ref: '#/components/schemas/GuestBuyer'
            - type: 'null'
          description: The guest buyer for the payment link.
        expires_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Expires At
          description: The expiration date and time for the payment link.
          examples:
            - '2024-06-01T00:00:00.000Z'
        connection_options:
          anyOf:
            - $ref: '#/components/schemas/TransactionConnectionOptions'
            - type: 'null'
          title: Connection Options
          description: Connection options for the payment link.
        external_identifier:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: External Identifier
          description: The merchant reference for the payment link.
          examples:
            - external-12345
        statement_descriptor:
          anyOf:
            - $ref: '#/components/schemas/StatementDescriptor'
            - type: 'null'
          description: The statement descriptor for the payment link.
        locale:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Locale
          description: The locale for the payment link.
          examples:
            - en
            - en-GB
            - pt
            - pt-BR
            - es
        merchant_name:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Merchant Name
          description: The merchant's display name.
          examples:
            - ACME Inc.
        merchant_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Url
          description: The merchant's website URL.
          examples:
            - https://merchant.example.com
        merchant_banner_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Banner Url
          description: The merchant's banner image URL.
          examples:
            - https://merchant.example.com/banner.png
        merchant_color:
          anyOf:
            - type: string
              format: color
            - type: 'null'
          title: Merchant Color
          description: The merchant's brand color.
          examples:
            - '#FF5733'
        merchant_message:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Merchant Message
          description: A message from the merchant.
          examples:
            - Thank you for your purchase!
        merchant_terms_and_conditions_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Terms And Conditions Url
          description: URL to the merchant's terms and conditions.
          examples:
            - https://merchant.example.com/terms
        merchant_favicon_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Favicon Url
          description: URL to the merchant's favicon.
          examples:
            - https://merchant.example.com/favicon.ico
        amount:
          type: integer
          maximum: 99999999
          minimum: 0
          title: Amount
          description: The amount for the payment link.
          examples:
            - 1299
        country:
          type: string
          pattern: ^[A-Z]{2}$
          title: Country
          description: The country code for the payment link.
          examples:
            - DE
            - GB
            - US
        currency:
          type: string
          pattern: ^[A-Z]{3}$
          title: Currency
          description: The currency code for the payment link.
          examples:
            - EUR
            - GBP
            - USD
        intent:
          description: The transaction intent for the payment link.
          default: authorize
          examples:
            - authorize
            - capture
          type: string
          enum:
            - authorize
            - capture
          title: TransactionIntent
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        return_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Return Url
          description: The return URL after payment completion.
          examples:
            - https://merchant.example.com/return
        cart_items:
          anyOf:
            - items:
                $ref: '#/components/schemas/CartItem'
              type: array
            - type: 'null'
          title: Cart Items
          description: The cart items for the payment link.
        metadata:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Metadata
          description: Arbitrary metadata for the payment link.
          examples:
            - order_id: ORD-12345
        payment_source:
          description: The way payment method information made it to this transaction.
          default: ecommerce
          examples:
            - ecommerce
          type: string
          enum:
            - ecommerce
            - moto
            - recurring
            - installment
            - card_on_file
          title: TransactionPaymentSource
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        store:
          type: boolean
          title: Store
          description: Whether to store the payment method for future use.
          default: false
          examples:
            - true
        buyer_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Buyer Id
          description: >-
            The ID of the buyer to associate the payment method with. Note: When
            `buyer_id` is provided, the payment link should be treated as a
            secret as it will allow the user to manage payment methods for the
            associated buyer.
          examples:
            - a1b2c3d4-5678-90ab-cdef-1234567890ab
        installment_count:
          anyOf:
            - type: integer
              maximum: 100
              minimum: 1
            - type: 'null'
          title: Installment Count
          description: The number of installments a buyer is required to make.
      additionalProperties: false
      type: object
      required:
        - amount
        - country
        - currency
      title: PaymentLinkCreate
    PaymentLink:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: The unique identifier for the payment link.
          examples:
            - a1b2c3d4-5678-90ab-cdef-1234567890ab
        type:
          type: string
          const: payment-link
          title: Type
          description: Always `payment-link`.
          default: payment-link
          examples:
            - payment-link
        url:
          type: string
          title: Url
          description: The URL for the payment link.
          examples:
            - https://example.com/link/a1b2c3d4-5678-90ab-cdef-1234567890ab
        expires_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Expires At
          description: The expiration date and time for the payment link.
          examples:
            - '2024-06-01T00:00:00.000Z'
        external_identifier:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: External Identifier
          description: The merchant reference for the payment link.
          examples:
            - external-12345
        statement_descriptor:
          anyOf:
            - $ref: '#/components/schemas/StatementDescriptor'
            - type: 'null'
          description: The statement descriptor for the payment link.
        locale:
          anyOf:
            - type: string
            - type: 'null'
          title: Locale
          description: The locale for the payment link.
          examples:
            - en
            - en-GB
            - pt
            - pt-BR
            - es
        merchant_name:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Merchant Name
          description: The merchant's display name.
          examples:
            - ACME Inc.
        merchant_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Url
          description: The merchant's website URL.
          examples:
            - https://merchant.example.com
        merchant_banner_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Banner Url
          description: The merchant's banner image URL.
          examples:
            - https://merchant.example.com/banner.png
        merchant_color:
          anyOf:
            - type: string
              maxLength: 100
              minLength: 1
            - type: 'null'
          title: Merchant Color
          description: The merchant's brand color.
          examples:
            - '#FF5733'
        merchant_message:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Merchant Message
          description: A message from the merchant.
          examples:
            - Thank you for your purchase!
        merchant_terms_and_conditions_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Terms And Conditions Url
          description: URL to the merchant's terms and conditions.
          examples:
            - https://merchant.example.com/terms
        merchant_favicon_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Merchant Favicon Url
          description: URL to the merchant's favicon.
          examples:
            - https://merchant.example.com/favicon.ico
        amount:
          type: integer
          maximum: 99999999
          minimum: 0
          title: Amount
          description: The amount for the payment link.
          examples:
            - 1299
        country:
          type: string
          pattern: ^[A-Z]{2}$
          title: Country
          description: The country code for the payment link.
          examples:
            - DE
            - GB
            - US
        currency:
          type: string
          pattern: ^[A-Z]{3}$
          title: Currency
          description: The currency code for the payment link.
          examples:
            - EUR
            - GBP
            - USD
        intent:
          description: The transaction intent for the payment link.
          examples:
            - authorize
            - capture
          type: string
          enum:
            - authorize
            - capture
          title: TransactionIntent
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        return_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Return Url
          description: The return URL after payment completion.
          examples:
            - https://merchant.example.com/return
        cart_items:
          anyOf:
            - items:
                $ref: '#/components/schemas/CartItem'
              type: array
            - type: 'null'
          title: Cart Items
          description: The cart items for the payment link.
          examples:
            - - amount:
                  currency: USD
                  value: 500
                name: Widget
                quantity: 2
        metadata:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Metadata
          description: Arbitrary metadata for the payment link.
          examples:
            - order_id: ORD-12345
        payment_source:
          description: The way payment method information made it to this transaction.
          examples:
            - ecommerce
          type: string
          enum:
            - ecommerce
            - moto
            - recurring
            - installment
            - card_on_file
          title: TransactionPaymentSource
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time the payment link was created.
          examples:
            - '2024-05-30T12:34:56.000Z'
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time the payment link was last updated.
          examples:
            - '2024-05-30T13:00:00.000Z'
        status:
          description: The status of the payment link.
          examples:
            - active
            - expired
            - completed
          type: string
          enum:
            - active
            - completed
            - expired
            - processing
          title: PaymentLinkStatus
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        buyer:
          anyOf:
            - $ref: '#/components/schemas/TransactionBuyer'
            - type: 'null'
          description: The buyer associated with the payment link.
        shipping_details:
          anyOf:
            - $ref: '#/components/schemas/ShippingDetails'
            - type: 'null'
          description: The shipping details for the payment link.
        connection_options:
          anyOf:
            - additionalProperties:
                additionalProperties: true
                type: object
              type: object
            - type: 'null'
          title: Connection Options
          description: The connection options for the payment link.
        store:
          type: boolean
          title: Store
          description: Whether the payment method was stored.
          default: false
        buyer_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Buyer Id
          description: The ID of the buyer to associate with the stored payment method.
          examples:
            - a1b2c3d4-5678-90ab-cdef-1234567890ab
        installment_count:
          anyOf:
            - type: integer
              maximum: 100
              minimum: 1
            - type: 'null'
          title: Installment Count
          description: The number of installments a buyer is required to make.
      additionalProperties: false
      type: object
      required:
        - id
        - url
        - amount
        - country
        - currency
        - intent
        - cart_items
        - payment_source
        - created_at
        - updated_at
        - status
      title: PaymentLink
    Error400:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `bad_request`
          default: bad_request
          examples:
            - bad_request
        status:
          type: integer
          title: Status
          description: Always `400`.
          default: 400
          examples:
            - 400
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Generic error
          examples:
            - Request failed validation
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error400
    Error401:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `unauthorized`
          default: unauthorized
          examples:
            - unauthorized
        status:
          type: integer
          title: Status
          description: Always `401`.
          default: 401
          examples:
            - 401
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: No valid API authentication found
          examples:
            - No valid API authentication found
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error401
    Error403:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `forbidden`
          default: forbidden
          examples:
            - forbidden
        status:
          type: integer
          title: Status
          description: Always `403`.
          default: 403
          examples:
            - 403
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Generic error
          examples:
            - Request failed validation
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error403
    Error404:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `not_found`
          default: not_found
          examples:
            - not_found
        status:
          type: integer
          title: Status
          description: Always `404`.
          default: 404
          examples:
            - 404
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: The resource could not be found
          examples:
            - The resource could not be found
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error404
    Error405:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `method_not_allowed`
          default: method_not_allowed
          examples:
            - method_not_allowed
        status:
          type: integer
          title: Status
          description: Always `405`.
          default: 405
          examples:
            - 405
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Method Not Allowed
          examples:
            - Method Not Allowed
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error405
    Error409:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `duplicate_record`
          default: duplicate_record
          examples:
            - duplicate_record
        status:
          type: integer
          title: Status
          description: Always `409`.
          default: 409
          examples:
            - 409
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Generic error
          examples:
            - Request failed validation
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
        resource_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Resource Id
          description: The ID of the conflicting resource.
          examples:
            - cdc70639-cb9c-4222-a73f-b8ce39f7821b
      additionalProperties: false
      type: object
      title: Error409
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Error425:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `too_early`
          default: too_early
          examples:
            - too_early
        status:
          type: integer
          title: Status
          description: Always `425`.
          default: 425
          examples:
            - 425
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Generic error
          examples:
            - Request failed validation
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error425
    Error429:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `too_many_requests`
          default: too_many_requests
          examples:
            - too_many_requests
        status:
          type: integer
          title: Status
          description: Always `429`.
          default: 429
          examples:
            - 429
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Generic error
          examples:
            - Request failed validation
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error429
    Error500:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `server_error`
          default: server_error
          examples:
            - server_error
        status:
          type: integer
          title: Status
          description: Always `500`.
          default: 500
          examples:
            - 500
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Request could not be processed
          examples:
            - Request could not be processed
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error500
    Error502:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `bad_gateway`
          default: bad_gateway
          examples:
            - bad_gateway
        status:
          type: integer
          title: Status
          description: Always `502`.
          default: 502
          examples:
            - 502
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Request could not be processed
          examples:
            - Request could not be processed
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error502
    Error504:
      properties:
        type:
          type: string
          const: error
          title: Type
          description: Always `error`.
          default: error
          examples:
            - error
        code:
          type: string
          title: Code
          description: Always `gateway_timeout`
          default: gateway_timeout
          examples:
            - gateway_timeout
        status:
          type: integer
          title: Status
          default: 504
        message:
          type: string
          title: Message
          description: A human readable message that provides more context to the error.
          default: Request could not be processed
          examples:
            - Request could not be processed
        details:
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type: array
          title: Details
          description: A list of details that further ellaborate on the error.
          default: []
      additionalProperties: false
      type: object
      title: Error504
    GuestBuyer:
      properties:
        display_name:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: Display Name
          description: The display name for the buyer.
          examples:
            - John Doe
        external_identifier:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: External Identifier
          description: The merchant identifier for this buyer.
          examples:
            - buyer-12345
        billing_details:
          anyOf:
            - $ref: '#/components/schemas/BillingDetails'
            - type: 'null'
          description: The billing name, address, email, and other fields for this buyer.
        account_number:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: Account Number
          description: The buyer account number
        shipping_details:
          anyOf:
            - $ref: '#/components/schemas/ShippingDetailsCreate'
            - type: 'null'
          description: The optional shipping details for this buyer.
      additionalProperties: false
      type: object
      title: GuestBuyer
    TransactionConnectionOptions:
      additionalProperties: false
      properties:
        account-updater:
          anyOf:
            - $ref: '#/components/schemas/AccountUpdaterOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `account-updater` connector,
            allowing for simulating different account updater responses.
        adyen-afterpay:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-afterpay` connector.
        adyen-alipay:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-alipay` connector.
        adyen-card:
          anyOf:
            - $ref: '#/components/schemas/AdyenCardOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-card` connector.
        adyen-cashapp:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-cashapp` connector.
        adyen-gcash:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-gcash` connector.
        adyen-giropay:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-giropay` connector.
        adyen-ideal:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-ideal` connector.
        adyen-paypay:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-paypay` connector.
        adyen-pix:
          anyOf:
            - $ref: '#/components/schemas/AdyenPixOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-pix` connector.
        adyen-sepa:
          anyOf:
            - $ref: '#/components/schemas/AdyenSepaOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-sepa` connector.
        adyen-sofort:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-sofort` connector.
        adyen-swish:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-swish` connector.
        adyen-vipps:
          anyOf:
            - $ref: '#/components/schemas/AdyenOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `adyen-vipps` connector.
        affirm-affirm:
          anyOf:
            - $ref: '#/components/schemas/AffirmOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `affirm-affirm` connector.
        braintree-card:
          anyOf:
            - $ref: '#/components/schemas/BraintreeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `braintree-card` connector.
        chaseorbital-card:
          anyOf:
            - $ref: '#/components/schemas/ChaseOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `chaseorbital-card` connector.
        cybersource-anti-fraud:
          anyOf:
            - $ref: '#/components/schemas/CybersourceAntiFraudOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `cybersource-anti-fraud`
            connector.
        cybersource-card:
          anyOf:
            - $ref: '#/components/schemas/CybersourceOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `cybersource-card` connector.
        cybersource-ideal:
          anyOf:
            - $ref: '#/components/schemas/CybersourceOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `cybersource-ideal` connector.
        cybersource-kcp:
          anyOf:
            - $ref: '#/components/schemas/CybersourceOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `cybersource-kcp` connector.
        dlocal-nequi:
          anyOf:
            - $ref: '#/components/schemas/DlocalOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `dlocal-nequi` connector.
        dlocal-upi:
          anyOf:
            - $ref: '#/components/schemas/DlocalUPIOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `dlocal-upi` connector.
        dlocal-pix:
          anyOf:
            - $ref: '#/components/schemas/DlocalPIXOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `dlocal-pix` connector.
        dlocal-gcash:
          anyOf:
            - $ref: '#/components/schemas/DlocalOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `dlocal-gcash` connector.
        ecommpay-card:
          anyOf:
            - $ref: '#/components/schemas/EcommpayOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `ecommpay-card` connector.
        fiserv-card:
          anyOf:
            - $ref: '#/components/schemas/FiservOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `fiserv-card` connector.
        forter-anti-fraud:
          anyOf:
            - $ref: '#/components/schemas/ForterAntiFraudOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `forter-anti-fraud` connector.
        gem-gem:
          anyOf:
            - $ref: '#/components/schemas/LatitudeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `gem-gem` connector.
        gem-gemds:
          anyOf:
            - $ref: '#/components/schemas/LatitudeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `gem-gemds` connector.
        givingblock-givingblock:
          anyOf:
            - $ref: '#/components/schemas/GivingBlockOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `givingblock-givingblock`
            connector.
        gocardless-gocardless:
          anyOf:
            - $ref: '#/components/schemas/GoCardlessOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `gocardless-gocardless`
            connector.
        latitude-latitude:
          anyOf:
            - $ref: '#/components/schemas/LatitudeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `latitude-latitude` connector.
        latitude-latitudeds:
          anyOf:
            - $ref: '#/components/schemas/LatitudeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `latitude-latitudeds` connector.
        mattilda-tapi:
          anyOf:
            - $ref: '#/components/schemas/MattildaTapiOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `mattilda-tapi` connector.
        mattilda-tapifintechs:
          anyOf:
            - $ref: '#/components/schemas/MattildaTapiOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `mattilda-tapifintechs`
            connector.
        monato-spei:
          anyOf:
            - $ref: '#/components/schemas/MonatoSpeiOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `monato-spei` connector.
        mock-card:
          anyOf:
            - $ref: '#/components/schemas/MockCardOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `mock-card` connector.
        mockds-card:
          anyOf:
            - $ref: '#/components/schemas/MockCardOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `mockds-card` connector.
        nuvei-card:
          anyOf:
            - $ref: '#/components/schemas/NuveiOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `nuvei-card` connector.
        nuvei-ideal:
          anyOf:
            - $ref: '#/components/schemas/NuveiIDealOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `nuvei-ideal` connector.
        nuvei-klarna:
          anyOf:
            - $ref: '#/components/schemas/NuveiKlarnaOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `nuvei-klarna` connector.
        nuvei-pse:
          anyOf:
            - $ref: '#/components/schemas/NuveiPSEOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `nuvei-pse` connector.
        oxxo-oxxo:
          anyOf:
            - $ref: '#/components/schemas/OxxoOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `oxxo-oxxo` connector.
        paypal-paypal:
          anyOf:
            - $ref: '#/components/schemas/PaypalOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `paypal-paypal` connector.
        paypal-paypalpaylater:
          anyOf:
            - $ref: '#/components/schemas/PaypalOptions'
            - type: 'null'
          default: null
          description: >-
            Custom options to be passed to the `paypal-paypalpaylater`
            connector.
        powertranz-card:
          anyOf:
            - $ref: '#/components/schemas/PowertranzOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `powertranz-card` connector.
        riskified-anti-fraud:
          anyOf:
            - $ref: '#/components/schemas/RiskifiedAntiFraudOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `riskified-anti-fraud` connector.
        stripe-affirm:
          anyOf:
            - $ref: '#/components/schemas/StripeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `stripe-affirm` connector.
        stripe-card:
          anyOf:
            - $ref: '#/components/schemas/StripeCardOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `stripe-card` connector.
        stripe-klarna:
          anyOf:
            - $ref: '#/components/schemas/StripeOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `stripe-klarna` connector.
        travelhub-card:
          anyOf:
            - $ref: '#/components/schemas/TravelhubOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `travelhub-card` connector.
        trustly-trustly:
          anyOf:
            - $ref: '#/components/schemas/TrustlyOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `trustly-trustly` connector.
        wpay-everydaypay:
          anyOf:
            - $ref: '#/components/schemas/WpayEverdaypayOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `wpay-everydaypay` connector.
        wpay-payto:
          anyOf:
            - $ref: '#/components/schemas/WpayPaytoOptions'
            - type: 'null'
          default: null
          description: Custom options to be passed to the `wpay-payto` connector.
      title: TransactionConnectionOptions
      type: object
    StatementDescriptor:
      properties:
        name:
          anyOf:
            - type: string
              maxLength: 22
              minLength: 5
            - type: 'null'
          title: Name
          description: Reflects your doing business as (DBA) name.
          examples:
            - ACME
        description:
          anyOf:
            - type: string
              maxLength: 22
              minLength: 5
            - type: 'null'
          title: Description
          description: A short description about the purchase.
          examples:
            - ACME San Jose Electronics
        city:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: City
          description: The merchant's city to be displayed in a statement descriptor.
          examples:
            - San Jose
        country:
          anyOf:
            - type: string
              pattern: ^[A-Z]{2}$
              examples:
                - DE
                - GB
                - US
            - type: 'null'
          title: Country
          description: >-
            The 2-letter ISO country code of the merchant to be displayed in a
            statement descriptor.
          examples:
            - US
        phone_number:
          anyOf:
            - type: string
              pattern: ^\+[1-9]\d{1,14}$
              examples:
                - '+14155552671'
                - '+442071838750'
            - type: 'null'
          title: Phone Number
          description: >-
            The value in the phone number field of a customer's statement which
            should be formatted according to the E164 number standard.
          examples:
            - '+1234567890'
        url:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Url
          description: The merchant's URL to be displayed in a statement descriptor.
          examples:
            - www.example.com
        postal_code:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Postal Code
          description: The merchant's postal code or zip code.
          examples:
            - '94560'
      additionalProperties: false
      type: object
      title: StatementDescriptor
      description: Information to show the user on their payments statement
    CartItem:
      properties:
        name:
          type: string
          maxLength: 255
          minLength: 1
          title: Name
          description: >-
            The name of the cart item. The value you set for this property may
            be truncated if the maximum length accepted by a payment service
            provider is less than 255 characters.
          examples:
            - GoPro HD
        quantity:
          type: integer
          maximum: 99999999
          exclusiveMinimum: 0
          title: Quantity
          description: >-
            The quantity of this item in the cart. This value cannot be negative
            or zero.
          examples:
            - 2
        unit_amount:
          type: integer
          maximum: 99999999
          minimum: 0
          title: Unit Amount
          description: >-
            The amount for an individual item represented as a monetary amount
            in the smallest currency unit for the given currency, for example
            `1299` USD cents represents `$12.99`. The amount sent through to the
            payment processor as unitary amount will be calculated to include
            the discount and tax values sent as part of this cart item.
          examples:
            - 1299
        discount_amount:
          anyOf:
            - type: integer
              maximum: 99999999
              minimum: 0
            - type: 'null'
          title: Discount Amount
          description: >-
            The amount discounted for this item represented as a monetary amount
            in the smallest currency unit for the given currency, for example
            `1299` USD cents represents `$12.99`.
          default: 0
          examples:
            - 0
        tax_amount:
          anyOf:
            - type: integer
              maximum: 99999999
              minimum: 0
            - type: 'null'
          title: Tax Amount
          description: >-
            The tax amount for this item represented as a monetary amount in the
            smallest currency unit for the given currency, for example `1299`
            USD cents represents `$12.99`.
          default: 0
          examples:
            - 0
        external_identifier:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: External Identifier
          description: >-
            An external identifier for the cart item. This can be set to any
            value and is not sent to the payment service.
          examples:
            - goprohd
        sku:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: Sku
          description: The SKU or product code for the item.
          examples:
            - GPHD1078
        upc:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Upc
          description: The UPC for the item.
          examples:
            - '012345678905'
        product_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Product Url
          description: The product URL for the item.
          examples:
            - https://example.com/catalog/go-pro-hd
        image_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Image Url
          description: The URL for the image of the item.
          examples:
            - https://example.com/images/go-pro-hd.jpg
        categories:
          anyOf:
            - items:
                type: string
                maxLength: 50
                minLength: 1
              type: array
            - type: 'null'
          title: Categories
          description: A list of strings containing product categories for the item.
          examples:
            - - camera
              - travel
              - gear
        product_type:
          anyOf:
            - type: string
              enum:
                - physical
                - discount
                - shipping_fee
                - sales_tax
                - digital
                - gift_card
                - store_credit
                - surcharge
              title: ProductType
              x-speakeasy-unknown-values: allow
              overlay: 1.0.0
            - type: 'null'
          description: The product type of the cart item.
          examples:
            - physical
        seller_country:
          anyOf:
            - type: string
              pattern: ^[A-Z]{2}$
              examples:
                - DE
                - GB
                - US
            - type: 'null'
          title: Seller Country
          description: The seller country of the cart item.
          examples:
            - US
            - GB
        tax_exempt:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Tax Exempt
          description: Whether the item is exempt of tax.
          examples:
            - false
        unit_of_measure:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Unit Of Measure
          description: The unit of measure or the unit of measure code.
          examples:
            - feet
            - kg
        commodity_code:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          title: Commodity Code
          description: Item commodity code. Generally a UNSPSC code.
          examples:
            - '43211503'
            - '84111502'
        description:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Description
          description: Brief item description.
          examples:
            - A brief description of an interesting item.
        duty_amount:
          anyOf:
            - type: integer
              maximum: 99999999
              minimum: 0
            - type: 'null'
          title: Duty Amount
          description: >-
            Item import or export duties represented as a monetary amount in the
            smallest currency unit for the given currency, for example `1299`
            cents to create an authorization for `$12.99`
          examples:
            - 1299
        shipping_amount:
          anyOf:
            - type: integer
              maximum: 99999999
              minimum: 0
            - type: 'null'
          title: Shipping Amount
          description: >-
            Freight/shipping amount represented as a monetary amount in the
            smallest currency unit for the given currency, for example `1299`
            cents to create an authorization for `$12.99`
          examples:
            - 1299
      additionalProperties: false
      type: object
      required:
        - name
        - quantity
        - unit_amount
      title: CartItem
    TransactionBuyer:
      properties:
        type:
          type: string
          const: buyer
          title: Type
          description: Always `buyer`.
          default: buyer
          examples:
            - buyer
        id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Id
          description: The ID for the buyer.
          examples:
            - fe26475d-ec3e-4884-9553-f7356683f7f9
        display_name:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: Display Name
          description: The display name for the buyer.
          examples:
            - John Doe
        external_identifier:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: External Identifier
          description: The merchant identifier for this buyer.
          examples:
            - buyer-12345
        billing_details:
          anyOf:
            - $ref: '#/components/schemas/BillingDetails'
            - type: 'null'
          description: The billing name, address, email, and other fields for this buyer.
        account_number:
          anyOf:
            - type: string
              maxLength: 200
              minLength: 1
            - type: 'null'
          title: Account Number
          description: The buyer account number.
      additionalProperties: false
      type: object
      title: TransactionBuyer
    ShippingDetails:
      properties:
        first_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: First Name
          description: The first name(s) or given name for the buyer.
          examples:
            - John
        last_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Last Name
          description: The last name, or family name, of the buyer.
          examples:
            - Doe
        email_address:
          anyOf:
            - type: string
              maxLength: 320
              minLength: 1
            - type: 'null'
          title: Email Address
          description: The email address for the buyer.
          examples:
            - john@example.com
        phone_number:
          anyOf:
            - type: string
              pattern: ^\+[1-9]\d{1,14}$
              examples:
                - '+14155552671'
                - '+442071838750'
            - type: 'null'
          title: Phone Number
          description: >-
            The phone number for the buyer which should be formatted according
            to the E164 number standard.
          examples:
            - '+1234567890'
        address:
          anyOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
          description: The billing address for the buyer.
        id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Id
          description: The ID for the shipping details.
          examples:
            - bf8c36ad-02d9-4904-b0f9-a230b149e341
        buyer_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Buyer Id
          description: The ID for the buyer.
          examples:
            - fe26475d-ec3e-4884-9553-f7356683f7f9
        type:
          type: string
          const: shipping-details
          title: Type
          description: Always `shipping-details`.
          default: shipping-details
          examples:
            - shipping-details
      additionalProperties: false
      type: object
      title: ShippingDetails
    ErrorDetail:
      properties:
        location:
          description: >-
            The part of the request where the property can be found that caused
            the error.
          examples:
            - body
          type: string
          enum:
            - query
            - body
            - path
            - header
            - unknown
          title: ErrorLocation
          x-speakeasy-unknown-values: allow
          overlay: 1.0.0
        pointer:
          anyOf:
            - type: string
              format: json-pointer
            - type: string
          title: Pointer
          description: A JSON pointer for the particular property that caused the error.
          examples:
            - /currency
        message:
          type: string
          title: Message
          description: A human-readdable explanation of the error.
          examples:
            - 'Unknown ISO 4217 currency code: USX'
        type:
          type: string
          title: Type
          description: The type of error that was raised for this property.
          examples:
            - value_error
      additionalProperties: false
      type: object
      required:
        - location
        - pointer
        - message
        - type
      title: ErrorDetail
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    BillingDetails:
      properties:
        first_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: First Name
          description: The first name(s) or given name for the buyer.
          examples:
            - John
        last_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Last Name
          description: The last name, or family name, of the buyer.
          examples:
            - Doe
        email_address:
          anyOf:
            - type: string
              maxLength: 320
              minLength: 1
            - type: 'null'
          title: Email Address
          description: The email address for the buyer.
          examples:
            - john@example.com
        phone_number:
          anyOf:
            - type: string
              pattern: ^\+[1-9]\d{1,14}$
              examples:
                - '+14155552671'
                - '+442071838750'
            - type: 'null'
          title: Phone Number
          description: >-
            The phone number for the buyer which should be formatted according
            to the E164 number standard.
          examples:
            - '+1234567890'
        address:
          anyOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
          description: The billing address for the buyer.
        tax_id:
          anyOf:
            - $ref: '#/components/schemas/TaxId'
            - type: 'null'
          description: The tax ID information associated with the billing details.
      additionalProperties: false
      type: object
      title: BillingDetails
    ShippingDetailsCreate:
      properties:
        first_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: First Name
          description: The first name(s) or given name for the buyer.
          examples:
            - John
        last_name:
          anyOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
          title: Last Name
          description: The last name, or family name, of the buyer.
          examples:
            - Doe
        email_address:
          anyOf:
            - type: string
              maxLength: 320
              minLength: 1
            - type: 'null'
          title: Email Address
          description: The email address for the buyer.
          examples:
            - john@example.com
        phone_number:
          anyOf:
            - type: string
              pattern: ^\+[1-9]\d{1,14}$
              examples:
                - '+14155552671'
                - '+442071838750'
            - type: 'null'
          title: Phone Number
          description: >-
            The phone number for the buyer which should be formatted according
            to the E164 number standard.
          examples:
            - '+1234567890'
        address:
          anyOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
          description: The billing address for the buyer.
      additionalProperties: false
      type: object
      title: ShippingDetailsCreate
    AccountUpdaterOptions:
      additionalProperties: false
      properties:
        response_code:
          anyOf:
            - const: updated
              type: string
            - type: 'null'
          default: null
          description: The type of response to simulate.
          examples:
            - updated
          title: Response Code
        account_number:
          anyOf:
            - maxLength: 18
              minLength: 12
              type: string
            - type: 'null'
          default: null
          description: >-
            When the `response_code` is set to `updated`, the payment method's
            account number will be updated to this value.
          examples:
            - '4242424242424242'
          title: Account Number
        expiration_month:
          anyOf:
            - type: string
              maxLength: 2
              minLength: 2
            - type: 'null'
          default: null
          description: >-
            When the `response_code` is set to `updated`, the payment method's
            expiration month will be updated to this value.
          examples:
            - '12'
          title: Expiration Month
        expiration_year:
          anyOf:
            - type: string
              maxLength: 4
              minLength: 4
            - type: 'null'
          default: null
          description: >-
            When the `response_code` is set to `updated`, the payment method's
            expiration year will be updated to this value.
          examples:
            - '2030'
          title: Expiration Year
        error_code:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: The type of error code to simulate.
          examples:
            - error
          title: Error Code
      title: AccountUpdaterOptions
      type: object
    AdyenOptions:
      additionalProperties: false
      properties:
        additionalData:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: Passes additional data to the Adyen API when creating a transaction.
          examples:
            - subMerchantID: '12345'
          title: Additionaldata
      title: AdyenOptions
      type: object
    AdyenCardOptions:
      additionalProperties: false
      properties:
        autoRescue:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: >-
            Set to `true` to enable Auto Rescue for a transaction. Use the
            `maxDaysToRescue` to specify a rescue window.
          examples:
            - true
          title: Autorescue
        maxDaysToRescue:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: >-
            The rescue window for a transaction, in days, when `autoRescue` is
            set to `true`. You can specify a value between 1 and 48. For cards,
            the default is one calendar month. For SEPA, the default is 42 days.
          examples:
            - 20
          title: Maxdaystorescue
        additionalData:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: Passes additional data to the Adyen API when creating a transaction.
          examples:
            - subMerchantID: '12345'
          title: Additionaldata
        autoRescueScenario:
          anyOf:
            - enum:
                - AutoRescueSuccessfulFirst
                - AutoRescueSuccessfulSecond
                - AutoRescueFailed
                - AutoRescueFraud
              title: AdyenCardAutoRescueScenariosEnum
              type: string
              x-speakeasy-unknown-values: allow
              overlay: 1.0.0
            - type: 'null'
          default: null
          description: >-
            The rescue scenario to simulate for a transaction, when `autoRescue`
            is set to `true`.
          examples:
            - AutoRescueSuccessfulFirst
        window_origin:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The origin of the window where the payment is initiated, used for 3D
            Secure authentication.
          examples:
            - https://example.com
          title: Window Origin
        splits:
          anyOf:
            - $ref: '#/components/schemas/AdyenSplitsOptions'
            - type: 'null'
          default: null
          description: Passes information of splitting payment amounts to the Adyen API.
      title: AdyenCardOptions
      type: object
    AdyenPixOptions:
      additionalProperties: false
      properties:
        additionalData:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: Passes additional data to the Adyen API when creating a transaction.
          examples:
            - subMerchantID: '12345'
          title: Additionaldata
        pixRecurring:
          anyOf:
            - $ref: '#/components/schemas/AdyenPixRecurringOptions'
            - type: 'null'
          default: null
          description: Passes `pixRecurring` data to Adyen
      title: AdyenPixOptions
      type: object
    AdyenSepaOptions:
      additionalProperties: false
      properties:
        autoRescue:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: >-
            Set to `true` to enable Auto Rescue for a transaction. Use the
            `maxDaysToRescue` to specify a rescue window.
          examples:
            - true
          title: Autorescue
        maxDaysToRescue:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: >-
            The rescue window for a transaction, in days, when `autoRescue` is
            set to `true`. You can specify a value between 1 and 48. For cards,
            the default is one calendar month. For SEPA, the default is 42 days.
          examples:
            - 20
          title: Maxdaystorescue
        additionalData:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: Passes additional data to the Adyen API when creating a transaction.
          examples:
            - subMerchantID: '12345'
          title: Additionaldata
        autoRescueSepaScenario:
          anyOf:
            - enum:
                - AutoRescueSuccessfulFirst
                - AutoRescueSuccessfulSecond
                - AutoRescueFailed
              title: AdyenAutoRescueSepaScenariosEnum
              type: string
              x-speakeasy-unknown-values: allow
              overlay: 1.0.0
            - type: 'null'
          default: null
          description: >-
            The rescue scenario to simulate for a transaction, when `autoRescue`
            is set to `true`.
          examples:
            - AutoRescueSuccessfulFirst
        ownerName:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: The name on the SEPA bank account.
          examples:
            - A. Schneider
          title: Ownername
      title: AdyenSepaOptions
      type: object
    AffirmOptions:
      additionalProperties: false
      properties:
        discounts:
          anyOf:
            - additionalProperties:
                additionalProperties: true
                type: object
              type: object
            - type: 'null'
          default: null
          description: Passes additional discounts to the Affirm widget.
          examples:
            - PRESDAY10:
                discount_amount: 1000
                discount_display_name: President's Day 10% off
              RETURN5:
                discount_amount: 500
                discount_display_name: Returning customer 5% discount
          title: Discounts
        itinerary:
          anyOf:
            - $ref: '#/components/schemas/AffirmItineraryOptions'
            - type: 'null'
          default: null
          description: Passes itinerary data to the Affirm API.
      title: AffirmOptions
      type: object
    BraintreeOptions:
      additionalProperties: false
      properties:
        discount_amount:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: >-
            Passes a discount amount to be applied to the transaction when using
            Braintree.
          examples:
            - 1000
          title: Discount Amount
        custom_fields:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: >-
            Passes `customFields` to the Braintree API when creating a new
            payment. Custom fields allow you to customize your checkout
            experience by collecting specific information about your customers
            and their purchases.
          examples:
            - checkout: primary
          title: Custom Fields
        dynamic_data_fields:
          anyOf:
            - $ref: '#/components/schemas/BraintreeDynamicDataFieldsOptions'
            - type: 'null'
          default: null
          description: Additional dynamic fields to pass to the Braintree API
      title: BraintreeOptions
      type: object
    ChaseOptions:
      additionalProperties: false
      properties:
        comments:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Custom order comment
          title: Comments
      title: ChaseOptions
      type: object
    CybersourceAntiFraudOptions:
      additionalProperties: false
      properties:
        merchant_defined_data:
          anyOf:
            - additionalProperties:
                maxLength: 5000
                minLength: 0
                type: string
              type: object
            - type: 'null'
          default: null
          description: >-
            A list of merchant defined data to be passed to the Cybersource
            Decision Manager API. Each key needs to be a numeric string.
          examples:
            - '1': data
          title: Merchant Defined Data
        meta_key_merchant_id:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The merchant ID to use for this transaction. This requires a meta
            key to be set up for use with Cybersource Decision Manager, and this
            overrides the connector configuration.
          examples:
            - merchant-1234
          title: Meta Key Merchant Id
        shipping_method:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: The shipping method for this transaction.
          examples:
            - sameday
          title: Shipping Method
      title: CybersourceAntiFraudOptions
      type: object
    CybersourceOptions:
      additionalProperties: false
      properties:
        meta_key_merchant_id:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The merchant ID to use for this transaction. This requires a meta
            key to be set up for use with Cybersource, and this overrides the
            connector configuration.
          examples:
            - merchant-1234
          title: Meta Key Merchant Id
        merchant_defined_information:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          default: null
          description: >-
            A list of merchant defined data to be passed to the Cybersource.
            Each key needs to be a numeric string.
          examples:
            - '1': data
          title: Merchant Defined Information
        ship_to_method:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: The shipping method for this transaction.
          examples:
            - sameday
          title: Ship To Method
        comments:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            Brief description of the order or any comment you wish to add to the
            order.
          examples:
            - This order is for a new customer
          title: Comments
      title: CybersourceOptions
      type: object
    DlocalOptions:
      additionalProperties: false
      properties:
        wallet:
          anyOf:
            - $ref: '#/components/schemas/DlocalWalletOptions'
            - type: 'null'
          default: null
          description: >-
            Passes `wallet` data to the dLocal API for those connectors that
            need it.
      title: DlocalOptions
      type: object
    DlocalUPIOptions:
      additionalProperties: false
      properties:
        wallet:
          anyOf:
            - $ref: '#/components/schemas/DlocalUPIWalletOptions'
            - type: 'null'
          default: null
          description: >-
            Passes `wallet` data to the dLocal API for those connectors that
            need it.
      title: DlocalUPIOptions
      type: object
    DlocalPIXOptions:
      additionalProperties: false
      properties:
        subscription:
          anyOf:
            - $ref: '#/components/schemas/DlocalPIXSubscriptionOptions'
            - type: 'null'
          default: null
          description: >-
            Passes `subscription` data to the dLocal API for those connectors
            that need it.
        scheduled_date:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            Defines scheduled payment start date. Must be provided in ISO 8601
            format `(YYYY-MM-DD`). If not specified, The default is 2 days in
            the future.
          examples:
            - '2030-12-01'
          title: Scheduled Date
      title: DlocalPIXOptions
      type: object
    EcommpayOptions:
      additionalProperties: false
      properties:
        booking_start_date:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The start date of the booking in ISO 8601 format (YYYY-MM-DD).
            Required for certain MCCs.
          examples:
            - '2030-12-01'
          title: Booking Start Date
        booking_end_date:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The end date of the booking in ISO 8601 format (YYYY-MM-DD).
            Required for certain MCCs.
          examples:
            - '2030-12-10'
          title: Booking End Date
      title: EcommpayOptions
      type: object
    FiservOptions:
      additionalProperties: false
      properties:
        installmentOptions:
          anyOf:
            - $ref: '#/components/schemas/FiservInstallmentOptions'
            - type: 'null'
          default: null
          description: >-
            Passes installment data to the Fiserv API. This is now also a
            dedicated feature on the Gr4vy API.
      title: FiservOptions
      type: object
    ForterAntiFraudOptions:
      additionalProperties: false
      properties:
        delivery_type:
          anyOf:
            - enum:
                - DIGITAL
                - PHYSICAL
                - HYBRID
              type: string
              x-speakeasy-unknown-values: allow
              overlay: 1.0.0
            - type: 'null'
          default: null
          description: The delivery type
          examples:
            - DIGITAL
          title: Delivery Type
        delivery_method:
          anyOf:
            - type: string
              maxLength: 50
              minLength: 1
            - type: 'null'
          default: null
          description: The delivery method
          title: Delivery Method
        is_guest_buyer:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: Defines if this payment is made using guest checkout.
          examples:
            - true
          title: Is Guest Buyer
        cart_items:
          anyOf:
            - items:
                $ref: '#/components/schemas/ForterAntiFraudOptionsCartItem'
              type: array
            - type: 'null'
          default: []
          description: A list of cart items details to pass to the Forter API.
          title: Cart Items
        total_discount:
          anyOf:
            - $ref: '#/components/schemas/ForterAntiFraudOptionsDiscount'
            - type: 'null'
          default: null
          description: Information about the discount applied to this order.
      title: ForterAntiFraudOptions
      type: object
    LatitudeOptions:
      additionalProperties: false
      properties:
        promotion_reference:
          anyOf:
            - maxLength: 128
              type: string
            - type: 'null'
          default: null
          description: The `promotionReference` field passed to the purchase API.
          examples:
            - promotion-123
          title: Promotion Reference
      title: LatitudeOptions
      type: object
    GivingBlockOptions:
      additionalProperties: false
      properties:
        defaultCryptocurrency:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            The default cryptocurrency to present at checkout. This can be used
            to ensure the user is presented with the same currency in both your
            checkout and the Giving Block checkout.
          examples:
            - BTC
          title: Defaultcryptocurrency
      title: GivingBlockOptions
      type: object
    GoCardlessOptions:
      additionalProperties: false
      properties:
        purpose_code:
          anyOf:
            - enum:
                - mortgage
                - utility
                - loan
                - dependant_support
                - gambling
                - retail
                - salary
                - personal
                - government
                - pension
                - tax
                - other
              type: string
              x-speakeasy-unknown-values: allow
              overlay: 1.0.0
            - type: 'null'
          default: null
          description: >-
            Specifies the high-level purpose of a mandate and/or payment using a
            set of pre-defined categories. Required for the PayTo scheme,
            optional for all others
          examples:
            - mortgage
            - utility
            - loan
            - dependant_support
            - gambling
            - retail
            - salary
            - personal
            - government
            - pension
            - tax
            - other
          title: Purpose Code
      title: GoCardlessOptions
      type: object
    MattildaTapiOptions:
      additionalProperties: false
      properties:
        payment_method_expires_at:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            Defines the date at which the payment will expire if not completed.
            Must be provided in ISO 8601 format `(YYYY-MM-DD`). If not
            specified, it defaults to 7 days in the future from the current
            date.
          examples:
            - '2030-12-01'
          title: Payment Method Expires At
      title: MattildaTapiOptions
      type: object
    MonatoSpeiOptions:
      additionalProperties: false
      properties:
        approval_url:
          description: Approval URL that will receive a charge payment method reference.
          examples:
            - https://example.com
          title: Approval Url
          type: string
      required:
        - approval_url
      title: MonatoSpeiOptions
      type: object
    MockCardOptions:
      additionalProperties: false
      properties:
        merchant_advice_code:
          anyOf:
            - $ref: '#/components/schemas/MockCardMerchantAdviceCodeOptions'
            - type: 'null'
          default: null
          description: Allows for mocking the merchant advice code.
        skip_retry:
          anyOf:
            - type: boolean
            - type: 'null'
          default: null
          description: When set to true, prevents retries on failed transactions.
          title: Skip Retry
      title: MockCardOptions
      type: object
    NuveiOptions:
      additionalProperties: false
      properties:
        customData:
          anyOf:
            - maxLength: 255
              type: string
            - type: 'null'
          default: null
          description: General data about the customer provided by the merchant.
          examples:
            - user=123,trusted=false
          title: Customdata
        airlineData:
          anyOf:
            - $ref: '#/components/schemas/NuveiAirlineDataOptions'
            - type: 'null'
          default: null
          description: Provides additional airline data for Nuvei payments.
      title: NuveiOptions
      type: object
    NuveiIDealOptions:
      additionalProperties: false
      properties:
        customData:
          anyOf:
            - maxLength: 255
              type: string
            - type: 'null'
          default: null
          description: Additional data to be sent to Nuvei.
          examples:
            - user=123,trusted=false
          title: Customdata
      title: NuveiIDealOptions
      type: object
    NuveiKlarnaOptions:
      additionalProperties: false
      properties:
        customData:
          anyOf:
            - maxLength: 255
              type: string
            - type: 'null'
          default: null
          description: Additional data to be sent to Nuvei.
          examples:
            - user=123,trusted=false
          title: Customdata
      title: NuveiKlarnaOptions
      type: object
    NuveiPSEOptions:
      additionalProperties: false
      properties:
        userType:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Customer type ("N" for persona natural, "J" for persona jurídica)
          examples:
            - 'N'
          title: Usertype
        userFisNumber:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Customer’s document type
          examples:
            - CC
          title: Userfisnumber
        fiscalNumber:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Customer’s document number
          examples:
            - CC
          title: Fiscalnumber
        bankCode:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: The bank code of the selected bank
          examples:
            - '5432'
          title: Bankcode
      title: NuveiPSEOptions
      type: object
    OxxoOptions:
      additionalProperties: false
      properties:
        payment_method_expires_at:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: >-
            Defines a custom expiration time (unix time) after which Oxxo
            payment requests are cancelled
          examples:
            - 1750074293
          title: Payment Method Expires At
        approval_url:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Approval URL that will receive a charge payment method reference.
          examples:
            - https://example.com
          title: Approval Url
      title: OxxoOptions
      type: object
    PaypalOptions:
      additionalProperties: false
      properties:
        additional_data:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          default: null
          description: >-
            Additional Set Transaction Context Values (STC) to be sent to PayPal
            as part of the transaction.
          examples:
            - sender_account_id: customer-1234
          title: Additional Data
        shipping:
          anyOf:
            - $ref: '#/components/schemas/PaypalShippingOptions'
            - type: 'null'
          default: null
          description: Shipping information to be passed to the PayPal API.
          examples:
            - options:
                - amount:
                    currency_code: USD
                    value: '10.00'
[...]
